# coding: utf-8

"""
    Skyfire SDK

    The Skyfire SDK is designed to allow agents to interact with the Skyfire platform to enable autonomous payments.

    The version of the OpenAPI document: 1.0.0
    Contact: support@skyfire.xyz
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from skyfire_sdk.models.eth_network_type import EthNetworkType
from typing import Optional, Set
from typing_extensions import Self

class Claim(BaseModel):
    """
    Claim
    """ # noqa: E501
    id: StrictStr
    created_at: Optional[StrictStr] = Field(default=None, alias="createdAt")
    value: StrictStr
    source_name: Optional[StrictStr] = Field(default=None, alias="sourceName")
    destination_name: Optional[StrictStr] = Field(default=None, alias="destinationName")
    source_address: StrictStr = Field(alias="sourceAddress")
    destination_address: StrictStr = Field(alias="destinationAddress")
    network: EthNetworkType
    nonce: StrictStr
    signature: StrictStr
    reference_id: StrictStr = Field(alias="referenceId")
    status: StrictStr
    updated_at: Optional[StrictStr] = Field(default=None, alias="updatedAt")
    tx_hash: Optional[StrictStr] = Field(default=None, alias="txHash")
    __properties: ClassVar[List[str]] = ["id", "createdAt", "value", "sourceName", "destinationName", "sourceAddress", "destinationAddress", "network", "nonce", "signature", "referenceId", "status", "updatedAt", "txHash"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Claim from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Claim from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "createdAt": obj.get("createdAt"),
            "value": obj.get("value"),
            "sourceName": obj.get("sourceName"),
            "destinationName": obj.get("destinationName"),
            "sourceAddress": obj.get("sourceAddress"),
            "destinationAddress": obj.get("destinationAddress"),
            "network": obj.get("network"),
            "nonce": obj.get("nonce"),
            "signature": obj.get("signature"),
            "referenceId": obj.get("referenceId"),
            "status": obj.get("status"),
            "updatedAt": obj.get("updatedAt"),
            "txHash": obj.get("txHash")
        })
        return _obj


