# coding: utf-8

"""
    Skyfire SDK

    The Skyfire SDK is designed to allow agents to interact with the Skyfire platform to enable autonomous payments.

    The version of the OpenAPI document: 1.0.0
    Contact: support@skyfire.xyz
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from skyfire_sdk.models.claim import Claim
from skyfire_sdk.models.eth_network_type import EthNetworkType
from skyfire_sdk.models.redemption_summary import RedemptionSummary
from typing import Optional, Set
from typing_extensions import Self

class Redemption(BaseModel):
    """
    Represents a redemption object.
    """ # noqa: E501
    redemption_id: StrictStr = Field(description="The unique identifier of the redemption.", alias="redemptionId")
    source_address: StrictStr = Field(description="The address from which the funds will be redeemed.", alias="sourceAddress")
    destination_address: StrictStr = Field(description="The address to which the funds will be sent.", alias="destinationAddress")
    source_name: Optional[StrictStr] = Field(default=None, description="The name of the source.", alias="sourceName")
    destination_name: Optional[StrictStr] = Field(default=None, description="The name of the destination.", alias="destinationName")
    network: EthNetworkType
    created_at: StrictStr = Field(description="The date and time when the wallet was created.", alias="createdAt")
    summary: Optional[RedemptionSummary] = None
    claims: List[Claim] = Field(description="Claims associated with the redemption.")
    __properties: ClassVar[List[str]] = ["redemptionId", "sourceAddress", "destinationAddress", "sourceName", "destinationName", "network", "createdAt", "summary", "claims"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Redemption from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of summary
        if self.summary:
            _dict['summary'] = self.summary.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in claims (list)
        _items = []
        if self.claims:
            for _item in self.claims:
                if _item:
                    _items.append(_item.to_dict())
            _dict['claims'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Redemption from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "redemptionId": obj.get("redemptionId"),
            "sourceAddress": obj.get("sourceAddress"),
            "destinationAddress": obj.get("destinationAddress"),
            "sourceName": obj.get("sourceName"),
            "destinationName": obj.get("destinationName"),
            "network": obj.get("network"),
            "createdAt": obj.get("createdAt"),
            "summary": RedemptionSummary.from_dict(obj["summary"]) if obj.get("summary") is not None else None,
            "claims": [Claim.from_dict(_item) for _item in obj["claims"]] if obj.get("claims") is not None else None
        })
        return _obj


