# coding: utf-8

"""
    Skyfire SDK

    The Skyfire SDK is designed to allow agents to interact with the Skyfire platform to enable autonomous payments.

    The version of the OpenAPI document: 1.0.0
    Contact: support@skyfire.xyz
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from skyfire_sdk.models.reloadly_controller_response_order import ReloadlyControllerResponseOrder
from skyfire_sdk.models.reloadly_redeem_code_respose import ReloadlyRedeemCodeRespose
from skyfire_sdk.models.reloadly_redeem_instructions_response import ReloadlyRedeemInstructionsResponse
from typing import Optional, Set
from typing_extensions import Self

class ReloadlyControllerResponse(BaseModel):
    """
    ReloadlyControllerResponse
    """ # noqa: E501
    order: Optional[ReloadlyControllerResponseOrder] = None
    redeem_instructions: Optional[ReloadlyRedeemInstructionsResponse] = Field(default=None, alias="redeemInstructions")
    redeem_code: Optional[ReloadlyRedeemCodeRespose] = Field(default=None, alias="redeemCode")
    __properties: ClassVar[List[str]] = ["order", "redeemInstructions", "redeemCode"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ReloadlyControllerResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of order
        if self.order:
            _dict['order'] = self.order.to_dict()
        # override the default output from pydantic by calling `to_dict()` of redeem_instructions
        if self.redeem_instructions:
            _dict['redeemInstructions'] = self.redeem_instructions.to_dict()
        # override the default output from pydantic by calling `to_dict()` of redeem_code
        if self.redeem_code:
            _dict['redeemCode'] = self.redeem_code.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ReloadlyControllerResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "order": ReloadlyControllerResponseOrder.from_dict(obj["order"]) if obj.get("order") is not None else None,
            "redeemInstructions": ReloadlyRedeemInstructionsResponse.from_dict(obj["redeemInstructions"]) if obj.get("redeemInstructions") is not None else None,
            "redeemCode": ReloadlyRedeemCodeRespose.from_dict(obj["redeemCode"]) if obj.get("redeemCode") is not None else None
        })
        return _obj


