# coding: utf-8

"""
    Skyfire SDK

    The Skyfire SDK is designed to allow agents to interact with the Skyfire platform to enable autonomous payments.

    The version of the OpenAPI document: 1.0.0
    Contact: support@skyfire.xyz
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from skyfire_sdk.models.reloadly_gift_card_api_request_params_send_email import ReloadlyGiftCardAPIRequestParamsSendEmail
from typing import Optional, Set
from typing_extensions import Self

class ReloadlyGiftCardAPIRequestParams(BaseModel):
    """
    Gift card request parameters for Reloadly.
    """ # noqa: E501
    recipient_email: StrictStr = Field(alias="recipientEmail")
    product_id: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, alias="productId")
    country_code: Optional[StrictStr] = Field(default=None, alias="countryCode")
    send_email: Optional[ReloadlyGiftCardAPIRequestParamsSendEmail] = Field(default=None, alias="sendEmail")
    note: Optional[StrictStr] = None
    amount: Optional[Union[StrictFloat, StrictInt]] = None
    __properties: ClassVar[List[str]] = ["recipientEmail", "productId", "countryCode", "sendEmail", "note", "amount"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ReloadlyGiftCardAPIRequestParams from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of send_email
        if self.send_email:
            _dict['sendEmail'] = self.send_email.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ReloadlyGiftCardAPIRequestParams from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "recipientEmail": obj.get("recipientEmail"),
            "productId": obj.get("productId"),
            "countryCode": obj.get("countryCode"),
            "sendEmail": ReloadlyGiftCardAPIRequestParamsSendEmail.from_dict(obj["sendEmail"]) if obj.get("sendEmail") is not None else None,
            "note": obj.get("note"),
            "amount": obj.get("amount")
        })
        return _obj


