# coding: utf-8

"""
    Skyfire SDK

    The Skyfire SDK is designed to allow agents to interact with the Skyfire platform to enable autonomous payments.

    The version of the OpenAPI document: 1.0.0
    Contact: support@skyfire.xyz
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Union
from skyfire_sdk.models.reloadly_products_response_item_brand import ReloadlyProductsResponseItemBrand
from skyfire_sdk.models.reloadly_products_response_item_category import ReloadlyProductsResponseItemCategory
from skyfire_sdk.models.reloadly_products_response_item_country import ReloadlyProductsResponseItemCountry
from skyfire_sdk.models.reloadly_products_response_item_redeem_instruction import ReloadlyProductsResponseItemRedeemInstruction
from typing import Optional, Set
from typing_extensions import Self

class ReloadlyProductsResponseItem(BaseModel):
    """
    ReloadlyProductsResponseItem
    """ # noqa: E501
    product_id: Union[StrictFloat, StrictInt] = Field(alias="productId")
    product_name: StrictStr = Field(alias="productName")
    logo_urls: List[StrictStr] = Field(alias="logoUrls")
    status: StrictStr
    brand: ReloadlyProductsResponseItemBrand
    category: ReloadlyProductsResponseItemCategory
    country: ReloadlyProductsResponseItemCountry
    redeem_instruction: ReloadlyProductsResponseItemRedeemInstruction = Field(alias="redeemInstruction")
    __properties: ClassVar[List[str]] = ["productId", "productName", "logoUrls", "status", "brand", "category", "country", "redeemInstruction"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ReloadlyProductsResponseItem from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of brand
        if self.brand:
            _dict['brand'] = self.brand.to_dict()
        # override the default output from pydantic by calling `to_dict()` of category
        if self.category:
            _dict['category'] = self.category.to_dict()
        # override the default output from pydantic by calling `to_dict()` of country
        if self.country:
            _dict['country'] = self.country.to_dict()
        # override the default output from pydantic by calling `to_dict()` of redeem_instruction
        if self.redeem_instruction:
            _dict['redeemInstruction'] = self.redeem_instruction.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ReloadlyProductsResponseItem from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "productId": obj.get("productId"),
            "productName": obj.get("productName"),
            "logoUrls": obj.get("logoUrls"),
            "status": obj.get("status"),
            "brand": ReloadlyProductsResponseItemBrand.from_dict(obj["brand"]) if obj.get("brand") is not None else None,
            "category": ReloadlyProductsResponseItemCategory.from_dict(obj["category"]) if obj.get("category") is not None else None,
            "country": ReloadlyProductsResponseItemCountry.from_dict(obj["country"]) if obj.get("country") is not None else None,
            "redeemInstruction": ReloadlyProductsResponseItemRedeemInstruction.from_dict(obj["redeemInstruction"]) if obj.get("redeemInstruction") is not None else None
        })
        return _obj


