# coding: utf-8

"""
    Skyfire SDK

    The Skyfire SDK is designed to allow agents to interact with the Skyfire platform to enable autonomous payments.

    The version of the OpenAPI document: 1.0.0
    Contact: support@skyfire.xyz
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from skyfire_sdk.models.vetric_facebook_event_search_response_search_query_combined_results_edges_inner import VetricFacebookEventSearchResponseSearchQueryCombinedResultsEdgesInner
from skyfire_sdk.models.vetric_facebook_event_search_response_search_query_combined_results_page_info import VetricFacebookEventSearchResponseSearchQueryCombinedResultsPageInfo
from typing import Optional, Set
from typing_extensions import Self

class VetricFacebookEventSearchResponseSearchQueryCombinedResults(BaseModel):
    """
    VetricFacebookEventSearchResponseSearchQueryCombinedResults
    """ # noqa: E501
    page_info: VetricFacebookEventSearchResponseSearchQueryCombinedResultsPageInfo
    has_hcm: Optional[StrictBool] = Field(default=None, description="Indicates if there is an HCM (Human Capital Management) related to the search.")
    degradation_level: Optional[StrictStr] = Field(default=None, description="Degradation level of the search results, if any.")
    has_iem_triggered: Optional[StrictBool] = Field(default=None, description="Indicates if an IEM (Intelligent Event Manager) has been triggered.")
    is_cache_hit: Optional[StrictBool] = Field(default=None, description="Indicates if the results are served from the cache.")
    edges: List[VetricFacebookEventSearchResponseSearchQueryCombinedResultsEdgesInner]
    speller_confidence: Optional[StrictStr] = Field(default=None, description="Confidence level of the speller.")
    corrected_query: Optional[StrictStr] = Field(default=None, description="Corrected query, if applicable.")
    __properties: ClassVar[List[str]] = ["page_info", "has_hcm", "degradation_level", "has_iem_triggered", "is_cache_hit", "edges", "speller_confidence", "corrected_query"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of VetricFacebookEventSearchResponseSearchQueryCombinedResults from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of page_info
        if self.page_info:
            _dict['page_info'] = self.page_info.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in edges (list)
        _items = []
        if self.edges:
            for _item in self.edges:
                if _item:
                    _items.append(_item.to_dict())
            _dict['edges'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of VetricFacebookEventSearchResponseSearchQueryCombinedResults from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "page_info": VetricFacebookEventSearchResponseSearchQueryCombinedResultsPageInfo.from_dict(obj["page_info"]) if obj.get("page_info") is not None else None,
            "has_hcm": obj.get("has_hcm"),
            "degradation_level": obj.get("degradation_level"),
            "has_iem_triggered": obj.get("has_iem_triggered"),
            "is_cache_hit": obj.get("is_cache_hit"),
            "edges": [VetricFacebookEventSearchResponseSearchQueryCombinedResultsEdgesInner.from_dict(_item) for _item in obj["edges"]] if obj.get("edges") is not None else None,
            "speller_confidence": obj.get("speller_confidence"),
            "corrected_query": obj.get("corrected_query")
        })
        return _obj


