# coding: utf-8

"""
    Skyfire SDK

    The Skyfire SDK is designed to allow agents to interact with the Skyfire platform to enable autonomous payments.

    The version of the OpenAPI document: 1.0.0
    Contact: support@skyfire.xyz
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List
from skyfire_sdk.models.vetric_facebook_user_search_response_combined_results import VetricFacebookUserSearchResponseCombinedResults
from skyfire_sdk.models.vetric_facebook_user_search_response_filter_type_sets_inner import VetricFacebookUserSearchResponseFilterTypeSetsInner
from typing import Optional, Set
from typing_extensions import Self

class VetricFacebookUserSearchResponse(BaseModel):
    """
    VetricFacebookUserSearchResponse
    """ # noqa: E501
    cache_id: StrictStr = Field(description="The unique cache ID of the search.")
    query_function: StrictStr = Field(description="The function used to query results.")
    logging_unit_id: StrictStr = Field(description="Unique ID used for logging.")
    combined_results: VetricFacebookUserSearchResponseCombinedResults
    filter_type_sets: List[VetricFacebookUserSearchResponseFilterTypeSetsInner]
    __properties: ClassVar[List[str]] = ["cache_id", "query_function", "logging_unit_id", "combined_results", "filter_type_sets"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of VetricFacebookUserSearchResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of combined_results
        if self.combined_results:
            _dict['combined_results'] = self.combined_results.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in filter_type_sets (list)
        _items = []
        if self.filter_type_sets:
            for _item in self.filter_type_sets:
                if _item:
                    _items.append(_item.to_dict())
            _dict['filter_type_sets'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of VetricFacebookUserSearchResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "cache_id": obj.get("cache_id"),
            "query_function": obj.get("query_function"),
            "logging_unit_id": obj.get("logging_unit_id"),
            "combined_results": VetricFacebookUserSearchResponseCombinedResults.from_dict(obj["combined_results"]) if obj.get("combined_results") is not None else None,
            "filter_type_sets": [VetricFacebookUserSearchResponseFilterTypeSetsInner.from_dict(_item) for _item in obj["filter_type_sets"]] if obj.get("filter_type_sets") is not None else None
        })
        return _obj


