# coding: utf-8

"""
    Skyfire SDK

    The Skyfire SDK is designed to allow agents to interact with the Skyfire platform to enable autonomous payments.

    The version of the OpenAPI document: 1.0.0
    Contact: support@skyfire.xyz
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from skyfire_sdk.models.vetric_instagram_location_map_response_pins_inner import VetricInstagramLocationMapResponsePinsInner
from typing import Optional, Set
from typing_extensions import Self

class VetricInstagramLocationMapResponse(BaseModel):
    """
    VetricInstagramLocationMapResponse
    """ # noqa: E501
    pins: List[VetricInstagramLocationMapResponsePinsInner]
    query_token: StrictStr = Field(description="Token for querying more results.")
    list_type: StrictStr = Field(description="Type of list being returned.")
    guides: Optional[List[Dict[str, Any]]] = Field(default=None, description="Guides related to the location.")
    guides_index: Optional[StrictInt] = Field(default=None, description="Index for guides pagination.")
    needs_story_fetch: Optional[StrictBool] = Field(default=None, description="Indicates if stories need to be fetched.")
    needs_profile_fetch: Optional[StrictBool] = Field(default=None, description="Indicates if profiles need to be fetched.")
    needs_guides_fetch: Optional[StrictBool] = Field(default=None, description="Indicates if guides need to be fetched.")
    status: StrictStr = Field(description="Status of the response.")
    __properties: ClassVar[List[str]] = ["pins", "query_token", "list_type", "guides", "guides_index", "needs_story_fetch", "needs_profile_fetch", "needs_guides_fetch", "status"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of VetricInstagramLocationMapResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in pins (list)
        _items = []
        if self.pins:
            for _item in self.pins:
                if _item:
                    _items.append(_item.to_dict())
            _dict['pins'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of VetricInstagramLocationMapResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "pins": [VetricInstagramLocationMapResponsePinsInner.from_dict(_item) for _item in obj["pins"]] if obj.get("pins") is not None else None,
            "query_token": obj.get("query_token"),
            "list_type": obj.get("list_type"),
            "guides": obj.get("guides"),
            "guides_index": obj.get("guides_index"),
            "needs_story_fetch": obj.get("needs_story_fetch"),
            "needs_profile_fetch": obj.get("needs_profile_fetch"),
            "needs_guides_fetch": obj.get("needs_guides_fetch"),
            "status": obj.get("status")
        })
        return _obj


