# coding: utf-8

"""
    Skyfire SDK

    The Skyfire SDK is designed to allow agents to interact with the Skyfire platform to enable autonomous payments.

    The version of the OpenAPI document: 1.0.0
    Contact: support@skyfire.xyz
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from skyfire_sdk.models.vetric_instagram_location_map_response_pins_inner_page_info_hours_schedule_inner import VetricInstagramLocationMapResponsePinsInnerPageInfoHoursScheduleInner
from typing import Optional, Set
from typing_extensions import Self

class VetricInstagramLocationMapResponsePinsInnerPageInfoHours(BaseModel):
    """
    VetricInstagramLocationMapResponsePinsInnerPageInfoHours
    """ # noqa: E501
    status: Optional[StrictStr] = Field(default=None, description="Current status of the location (Open/Closed).")
    current_status: Optional[StrictStr] = Field(default=None, description="Current status of the location.")
    hours_today: Optional[StrictStr] = Field(default=None, description="Business hours for today.")
    schedule: Optional[List[VetricInstagramLocationMapResponsePinsInnerPageInfoHoursScheduleInner]] = None
    is_open: Optional[StrictBool] = Field(default=None, description="Indicates if the location is currently open.")
    __properties: ClassVar[List[str]] = ["status", "current_status", "hours_today", "schedule", "is_open"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of VetricInstagramLocationMapResponsePinsInnerPageInfoHours from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in schedule (list)
        _items = []
        if self.schedule:
            for _item in self.schedule:
                if _item:
                    _items.append(_item.to_dict())
            _dict['schedule'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of VetricInstagramLocationMapResponsePinsInnerPageInfoHours from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "status": obj.get("status"),
            "current_status": obj.get("current_status"),
            "hours_today": obj.get("hours_today"),
            "schedule": [VetricInstagramLocationMapResponsePinsInnerPageInfoHoursScheduleInner.from_dict(_item) for _item in obj["schedule"]] if obj.get("schedule") is not None else None,
            "is_open": obj.get("is_open")
        })
        return _obj


