# coding: utf-8

"""
    Skyfire SDK

    The Skyfire SDK is designed to allow agents to interact with the Skyfire platform to enable autonomous payments.

    The version of the OpenAPI document: 1.0.0
    Contact: support@skyfire.xyz
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class VetricLinkedInCompanyPeopleResponsePeopleInner(BaseModel):
    """
    VetricLinkedInCompanyPeopleResponsePeopleInner
    """ # noqa: E501
    name: StrictStr = Field(description="Name of the LinkedIn member. May be displayed as 'LinkedIn Member' due to privacy settings.")
    position: StrictStr = Field(description="Job title or position of the LinkedIn member.")
    location: StrictStr = Field(description="Geographic location of the LinkedIn member.")
    urn: StrictStr = Field(description="Unique LinkedIn profile URN.")
    image: Optional[StrictStr] = Field(default=None, description="URL to the profile image of the LinkedIn member. Can be null if no image is available.")
    __properties: ClassVar[List[str]] = ["name", "position", "location", "urn", "image"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of VetricLinkedInCompanyPeopleResponsePeopleInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of VetricLinkedInCompanyPeopleResponsePeopleInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "position": obj.get("position"),
            "location": obj.get("location"),
            "urn": obj.get("urn"),
            "image": obj.get("image")
        })
        return _obj


