# coding: utf-8

"""
    Skyfire SDK

    The Skyfire SDK is designed to allow agents to interact with the Skyfire platform to enable autonomous payments.

    The version of the OpenAPI document: 1.0.0
    Contact: support@skyfire.xyz
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class VetricMarketplaceSearchResponseDataMarketplaceSearchFeedUnitsEdgesInnerNodeRow3(BaseModel):
    """
    VetricMarketplaceSearchResponseDataMarketplaceSearchFeedUnitsEdgesInnerNodeRow3
    """ # noqa: E501
    typename: Optional[StrictStr] = Field(default=None, description="Type name of the row object.", alias="__typename")
    snippet_type: Optional[StrictStr] = Field(default=None, description="Type of snippet, such as 'TEXT'.")
    is_marketplace_feed_content_entity_snippet: Optional[StrictStr] = Field(default=None, description="Indicator for row snippet type.", alias="__isMarketplaceFeedContentEntitySnippet")
    lines_before_truncation: Optional[StrictInt] = Field(default=None, description="Number of lines before truncation, if applicable.")
    text: Optional[StrictStr] = Field(default=None, description="Text content of the snippet, such as mileage.")
    id: Optional[StrictStr] = Field(default=None, description="Unique identifier for the row snippet.")
    __properties: ClassVar[List[str]] = ["__typename", "snippet_type", "__isMarketplaceFeedContentEntitySnippet", "lines_before_truncation", "text", "id"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of VetricMarketplaceSearchResponseDataMarketplaceSearchFeedUnitsEdgesInnerNodeRow3 from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if lines_before_truncation (nullable) is None
        # and model_fields_set contains the field
        if self.lines_before_truncation is None and "lines_before_truncation" in self.model_fields_set:
            _dict['lines_before_truncation'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of VetricMarketplaceSearchResponseDataMarketplaceSearchFeedUnitsEdgesInnerNodeRow3 from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "__typename": obj.get("__typename"),
            "snippet_type": obj.get("snippet_type"),
            "__isMarketplaceFeedContentEntitySnippet": obj.get("__isMarketplaceFeedContentEntitySnippet"),
            "lines_before_truncation": obj.get("lines_before_truncation"),
            "text": obj.get("text"),
            "id": obj.get("id")
        })
        return _obj


