# coding: utf-8

"""
    Skyfire SDK

    The Skyfire SDK is designed to allow agents to interact with the Skyfire platform to enable autonomous payments.

    The version of the OpenAPI document: 1.0.0
    Contact: support@skyfire.xyz
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from skyfire_sdk.models.bridge_virtual_account import BridgeVirtualAccount
from skyfire_sdk.models.eth_network_type import EthNetworkType
from skyfire_sdk.models.wallet_type import WalletType
from typing import Optional, Set
from typing_extensions import Self

class WalletDetails(BaseModel):
    """
    Represents a list of wallets with their details.
    """ # noqa: E501
    address: StrictStr = Field(description="The address of the wallet.")
    bridge_virtual_account: Optional[BridgeVirtualAccount] = Field(default=None, alias="bridgeVirtualAccount")
    type: WalletType
    created_at: StrictStr = Field(description="The date and time when the wallet was created. In ISO 8601 format.", alias="createdAt")
    network: Optional[EthNetworkType] = None
    __properties: ClassVar[List[str]] = ["address", "bridgeVirtualAccount", "type", "createdAt", "network"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of WalletDetails from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of bridge_virtual_account
        if self.bridge_virtual_account:
            _dict['bridgeVirtualAccount'] = self.bridge_virtual_account.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of WalletDetails from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "address": obj.get("address"),
            "bridgeVirtualAccount": BridgeVirtualAccount.from_dict(obj["bridgeVirtualAccount"]) if obj.get("bridgeVirtualAccount") is not None else None,
            "type": obj.get("type"),
            "createdAt": obj.get("createdAt"),
            "network": obj.get("network")
        })
        return _obj


